﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace A {
	namespace A {
		class B {}
	}
	class B {}
	namespace C {
		class D {}
	}
}

namespace A.C {
	class E {}
}

namespace N1 {
	class C1 {}
}

class B {}

namespace A {
	class Y {
		public static void m() {
			Console.WriteLine(typeof(B));
			// Console.WriteLine(typeof(C1));

			// Relative path
			Console.WriteLine(typeof(C.D));
			Console.WriteLine(typeof(C.E));

			// Absolute path
			Console.WriteLine(typeof(N1.C1));

			// Forcing absolute path using an alias
			Console.WriteLine(typeof(A.B)); // leads to A.A.B
			Console.WriteLine(typeof(global::A.B)); // leads to A.B
			Console.WriteLine(typeof(global::A.A.B)); // leads to A.A.B
			Console.WriteLine(typeof(global::B)); // leads to B
		}
	}
}

namespace A.C {
	class Z {
		public static void m() {
			// Relative path
			Console.WriteLine(typeof(D));
			Console.WriteLine(typeof(E));

			Console.WriteLine(typeof(C.D));
			Console.WriteLine(typeof(C.E));

			Console.WriteLine(typeof(B));
			
			Console.WriteLine(typeof(A.B));

			// Absolute path
			Console.WriteLine(typeof(N1.C1));

			// Forcing absolute path using an alias
			Console.WriteLine(typeof(global::B)); // leads to B
		}
	}
}

class Program {
	static void Main(string[] args) {
		Console.WriteLine("--- in global namespace (from Program):");
		Console.WriteLine(typeof(B));
		Console.WriteLine(typeof(A.C.D));
		Console.WriteLine(typeof(A.C.E));
		Console.WriteLine(typeof(A.B));
		Console.WriteLine(typeof(A.A.B));

		// Console.WriteLine(typeof(C.D));	// Compilation error
		// Console.WriteLine(typeof(C.E));	// Compilation error

		Console.WriteLine("--- in A (from A.Y):");
		A.Y.m();

		Console.WriteLine("--- in A.C (from A.C.Z):");
		A.C.Z.m();

		Console.Write("Press ENTER to show more complex examples ...");
		Console.ReadLine();

		Console.WriteLine("--- in X1:");
		X1.Y.m();

		Console.WriteLine("--- in X2:");
		X2.Y.m();
	}
}

namespace X1 {
	using A;

	class Y {
		public static void m() {
			Console.WriteLine(typeof(B));
			// Console.WriteLine(typeof(C.D));	// Compilation error
			// Console.WriteLine(typeof(C.E));	// Compilation error
		}
	}
}

namespace X2 {
	using A.C;
	using A;
	// using A.C;	// Compilation error

	using AAA = A;

	class Y {
		public static void m() {
			Console.WriteLine("+++ m() +++");
			Console.WriteLine(typeof(D));
			Console.WriteLine(typeof(E));
			Console.WriteLine(typeof(B));
			Console.WriteLine(typeof(A.B));

			Console.WriteLine();
			Console.WriteLine(typeof(global::B));
			Console.WriteLine(typeof(global::A.B));
			Console.WriteLine(typeof(global::A.A.B));

			Console.WriteLine();
			Console.WriteLine(typeof(AAA.B));
			Console.WriteLine(typeof(AAA::B));
		}
	}
}
